// Kasiopea 2013 http://ksp.mff.cuni.cz/akce/kasiopea
// Autorské řešení 2. úlohy "Permutace"
// Při překládání nastavte svému překladači
// jazyka C normu C99 nebo novější.
// (V GCC například přepínače -std=c99 nebo -std=c11)
#include<stdio.h>

#define MAXN 110000

int N, vysledek;
int P[MAXN], navstiveny[MAXN];

// Euklidův algoritmus k nalezení
// největšího společného dělitele
int gcd(int a, int b) {
	int t;
	while (b != 0) {
		t = b;
		b = a % b;
		a = t;
	}
	return a;
}

int main() {
	freopen("vstup.in", "r", stdin);
	scanf("%d", &N);
	int k, l;
	for (int i = 0; i < N; i++) {
		scanf("%d", &k);
		P[i] = k;
		navstiveny[i] = 0;
	}
	fclose(stdin);

	vysledek = 1;
	for (int i = 0; i < N; i++) {
		// Pro každé i projdeme příslušný cyklus
		// a spočteme nejmenší společný násobek
		// jeho délky a aktuálního mezivýsledku
		if (!navstiveny[i]) {
			int delka = 0, p = i;
			do  {
				navstiveny[p] = 1;
				p = P[p];
				delka++;
			}
			while (!navstiveny[p]);
			vysledek = vysledek / gcd(delka, vysledek) * delka;
		}
	}
	freopen("vystup.out", "w", stdout);
	printf("%d\n", vysledek);
	fclose(stdout);
	return 0;
}
