// Kasiopea 2013 http://ksp.mff.cuni.cz/akce/kasiopea
// Autorské řešení 4. úlohy "Nulový strom"
// Při překládání nastavte svému překladači
// jazyka C normu C99 nebo novější.
// (V GCC například přepínače -std=c99 nebo -std=c11)
#include<stdio.h>
#include<stdlib.h>

#define MAXN 100000

// Počet vrcholů a jejich ohodnocení
int N, v[MAXN];

// E[i] udává seznam vrcholů, do kterých z i vede hrana
// EN[i] udává počet těchto vrcholů, EC[i] kapacitu pole E[i]
int *E[MAXN], EN[MAXN], EC[MAXN];

int max(int a, int b) {
	return a < b ? b : a;
}

void pridej_hranu(int u, int w) {
	if (EC[u] == EN[u]) {
		EC[u] = (EC[u] == 0 ? 1 : 2 * EC[u]);
		int *tmp = (int*)malloc(EC[u] * sizeof(int));
		for (int i = 0; i < EN[u]; i++) {
			tmp[i] = E[u][i];
		}
		E[u] = tmp;
	}
	E[u][EN[u]++] = w;
}

// DFS průchod na vrcholu x, přišli jsme z vrcholu otec,
// do M_x a P_x bude uložen výstup.
void dfs(int x, int otec, int *M_x, int *P_x) {
	int M_max = 0, P_max = 0, M_i = 0, P_i = 0;
	for (int i = 0; i < EN[x]; i++)
		if (E[x][i] != otec) {
			dfs(E[x][i], x, &M_i, &P_i);
			M_max = max(M_i,M_max);
			P_max = max(P_i,P_max);
		}

	*M_x = M_max;
	*P_x = P_max;
	int nove_ohodnoceni = v[x] + *P_x - *M_x;
	if (nove_ohodnoceni >= 0) *M_x += nove_ohodnoceni;
	else *P_x += (-nove_ohodnoceni);
}

int main() {
	freopen("vstup.in", "r", stdin);
	scanf("%d", &N);
	for (int i = 0; i < N; i++)
		scanf("%d", &v[i]);
	for (int i = 0; i < N-1; i++) {
		int u,w;
		scanf("%d%d", &u, &w);
		// Hrany se ukladají orientované,
		// takže je musíme přidat v obou směrech
		pridej_hranu(u, w);
		pridej_hranu(w, u);
	}
	fclose(stdin);

	int M_0 = 0, P_0 = 0;
	dfs(0, -1, &M_0, &P_0);
	freopen("vystup.out", "w", stdout);
	printf("%d\n", M_0+P_0);
	return 0;
}
